/**
 * Copyright (c) 2009 Motorola.
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     Eric Sousa Dias (Motorola) - Initial version
 */

import java.io.File;
import java.io.FileOutputStream;
import java.io.OutputStreamWriter;
import java.io.Writer;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Task;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

/**
 * The GeneratingProperties task creates proper bundle (property files)
 * from the Localization Data file for the build export.
 * 
 * @author Eric Dias
 * @since 1.0
 */
public class GeneratingProperties extends Task{
	
	private String source;
	private String dest;

	public void setSource(String msg) {
		// ant always replaces properties for attributes
		source = msg;
	}

	public void setDest(String msg) {
		// ant always replaces properties for attributes
		dest = msg;
	}

	public void execute() throws BuildException {
		readXML();
	}
	
	private void readXML() {
	
		try {

			File file = new File(source);
			DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
			DocumentBuilder db = dbf.newDocumentBuilder();
			
			Document doc = db.parse(file);
			
			NodeList nodeList = doc.getElementsByTagName("locale");
			
			for (int s = 0; s < nodeList.getLength(); s++) {

				Node fstNode = nodeList.item(s);
				
				if (fstNode.getNodeType() == Node.ELEMENT_NODE) {

					Element fstElmnt = (Element) fstNode;

					String fileName = "messages_" + fstElmnt.getAttribute("language")
					                + "-" + fstElmnt.getAttribute("country") + ".properties";

					//Create the files
					Writer message = new OutputStreamWriter(new FileOutputStream(dest + "/" + fileName), "ISO-8859-1");
					NodeList fstNmElmntLst = fstElmnt.getChildNodes();
					
					for (int i = 0; i < fstNmElmntLst.getLength(); i++) {
						
						Node node = fstNmElmntLst.item(i);
						
						if (node.getNodeType() == Node.ELEMENT_NODE) {
							Element nodeElmnt = (Element) node;
							
							String a = (nodeElmnt.getAttribute("key")).toUpperCase() + "="
							+ nodeElmnt.getAttribute("value") + "\n";
							message.write(a);

						}
					}
					
					message.close();
					
				}

			}
		} catch (Exception e) {
			System.exit(1);
		}
	}



}